﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using System.IO;
using System.Configuration;

/*============================================================================
  File:     Program.cs
 
  Summary:  This program implements updating a 
            Filestream-enabled column in SQL Server 2008

  Date:     August 2008

  SQL Server Version: 10.0.1600.22 (RTM)
------------------------------------------------------------------------------
  Written by Bob Beauchemin, SQLskills.com

  For more scripts and sample code, check out http://www.SQLskills.com

  This script is intended only as a supplement to SQL Server Jumpstart program.
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

namespace FileStreamUpdate
{
    class Program
    {
        static void Main(string[] args)
        {
            string connString = ConfigurationManager.ConnectionStrings["Northwind"].ConnectionString;

            using (SqlConnection connection = new SqlConnection(connString))
            {
                connection.Open();

                SqlCommand command = new SqlCommand("", connection);
                command.CommandText = "select Top(1) Photo.PathName(), "
                + "GET_FILESTREAM_TRANSACTION_CONTEXT () from employees2";

                SqlTransaction tran = connection.BeginTransaction(
                    System.Data.IsolationLevel.ReadCommitted);
                command.Transaction = tran;

                using (SqlDataReader reader = command.ExecuteReader())
                {
                    while (reader.Read())
                    {
                        // Get the pointer for file 
                        string path = reader.GetString(0);
                        byte[] transactionContext = reader.GetSqlBytes(1).Buffer;

                        // Create the SqlFileStream
                        Stream fileStream = new SqlFileStream(path,
                            (byte[])reader.GetValue(1),
                            FileAccess.Write,
                            FileOptions.SequentialScan, 0);

                        // Write a single byte to the file. This will
                        // replace any data in the file.
                        fileStream.WriteByte(0x01);

                        fileStream.Close();
                    }
                }
                tran.Commit();
            }
        }
    }
}
